import { RouterConfig } from "./types";
import { APIGatewayProxyHandler, APIGatewayProxyHandlerV2 } from "aws-lambda";
import { APIGatewayVersion, RouteHandlers } from "./router";
export declare type ApiGatewayHandlerWithOpenApi = APIGatewayProxyHandler & {
    toOpenApiPart: () => object;
};
export declare type ApiGatewayHandlerV2WithOpenApi = APIGatewayProxyHandlerV2 & {
    toOpenApiPart: () => object;
};
export declare type VersionedHandlerType<V extends APIGatewayVersion> = V extends "V1" ? ApiGatewayHandlerWithOpenApi : ApiGatewayHandlerV2WithOpenApi;
export declare const APIEventHandler: (routes: RouteHandlers<"V1">, config?: RouterConfig) => VersionedHandlerType<"V1">;
