"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.logRequestResponsev2 = exports.logRequestResponse = void 0;
const keysExcept = (r, ignore) => ((ignore || []).length
    ? Object.keys(r).filter((h) => !(ignore === null || ignore === void 0 ? void 0 : ignore.find((igh) => igh.toLowerCase() === h.toLowerCase())))
    : Object.keys(r)).reduce((p, n) => ({ ...p, [n]: r[n] }), {});
const logRequestResponse = (event, config) => {
    const { logConfig } = config || {};
    const logger = (logConfig === null || logConfig === void 0 ? void 0 : logConfig.logger) || (config || {}).logger;
    if (logger && (logConfig === null || logConfig === void 0 ? void 0 : logConfig.logRequests)) {
        const { body, headers, multiValueHeaders, ...rest } = event;
        const headersToLog = headers ? keysExcept(headers, logConfig.ignoredHeaders) : {};
        const mvHeadersToLog = multiValueHeaders
            ? keysExcept(multiValueHeaders, logConfig.ignoredHeaders)
            : {};
        const bodyToLog = logConfig.logRequestBody ? body : undefined;
        const objectToLog = {
            ...rest,
            ...(bodyToLog ? { body: bodyToLog } : undefined),
            headers: headersToLog,
            multiValueHeaders: mvHeadersToLog,
        };
        logger.info("Request received", objectToLog);
    }
};
exports.logRequestResponse = logRequestResponse;
const logRequestResponsev2 = (event, config) => {
    const { logConfig } = config || {};
    const logger = (logConfig === null || logConfig === void 0 ? void 0 : logConfig.logger) || (config || {}).logger;
    if (logger && (logConfig === null || logConfig === void 0 ? void 0 : logConfig.logRequests)) {
        const { body, headers, ...rest } = event;
        const headersToLog = headers ? keysExcept(headers, logConfig.ignoredHeaders) : {};
        const bodyToLog = logConfig.logRequestBody ? body : undefined;
        const objectToLog = {
            ...rest,
            ...(bodyToLog ? { body: bodyToLog } : undefined),
            headers: headersToLog,
        };
        logger.info("Request received", objectToLog);
    }
};
exports.logRequestResponsev2 = logRequestResponsev2;
